diff -Naur a/drivers/usb/serial/option.c b/drivers/usb/serial/option.c
--- a/drivers/usb/serial/option.c	2020-11-16 13:28:35.826066016 -0800
+++ b/drivers/usb/serial/option.c	2020-11-16 13:31:40.241339225 -0800
@@ -1109,7 +1109,16 @@
 	{ USB_DEVICE_AND_INTERFACE_INFO(QUECTEL_VENDOR_ID, QUECTEL_PRODUCT_RM500Q, 0xff, 0, 0) },
 	{ USB_DEVICE_AND_INTERFACE_INFO(QUECTEL_VENDOR_ID, QUECTEL_PRODUCT_RM500Q, 0xff, 0xff, 0x10),
 	  .driver_info = ZLP },
-
+	{ USB_DEVICE(0x05C6, 0x9090) }, /* Quectel UC15 */
+	{ USB_DEVICE(0x05C6, 0x9003) }, /* Quectel UC20 */
+	{ USB_DEVICE(0x2C7C, 0x0125) }, /* Quectel EC25 */
+	{ USB_DEVICE(0x2C7C, 0x0121) }, /* Quectel EC21 */
+	{ USB_DEVICE(0x05C6, 0x9215) }, /* Quectel EC20 */
+	{ USB_DEVICE(0x2C7C, 0x0191) }, /* Quectel EG91 */
+	{ USB_DEVICE(0x2C7C, 0x0195) }, /* Quectel EG95 */
+	{ USB_DEVICE(0x2C7C, 0x0306) }, /* Quectel EG06/EP06/EM06 */
+	{ USB_DEVICE(0x2C7C, 0x0296) }, /* Quectel BG96 */
+	{ USB_DEVICE(0x2C7C, 0x0435) }, /* Quectel AG35 */
 	{ USB_DEVICE(CMOTECH_VENDOR_ID, CMOTECH_PRODUCT_6001) },
 	{ USB_DEVICE(CMOTECH_VENDOR_ID, CMOTECH_PRODUCT_CMU_300) },
 	{ USB_DEVICE(CMOTECH_VENDOR_ID, CMOTECH_PRODUCT_6003),
@@ -2052,6 +2061,7 @@
 #ifdef CONFIG_PM
 	.suspend           = usb_wwan_suspend,
 	.resume            = usb_wwan_resume,
+	.reset_resume	   = usb_wwan_resume,
 #endif
 };
 
@@ -2087,6 +2097,25 @@
 	if (device_flags & NUMEP2 && iface_desc->bNumEndpoints != 2)
 		return -ENODEV;
 
+
+	// Added by Quectel
+   //Quectel UC20's interface 4 can be used as USB network device
+   if (serial->dev->descriptor.idVendor == cpu_to_le16(0x05C6) && 
+       serial->dev->descriptor.idProduct == cpu_to_le16(0x9003)
+       && serial->interface->cur_altsetting->desc.bInterfaceNumber >= 4)
+       return -ENODEV;
+
+   //Quectel EC20's interface 4 can be used as USB network device
+   if (serial->dev->descriptor.idVendor == cpu_to_le16(0x05C6) &&
+       serial->dev->descriptor.idProduct == cpu_to_le16(0x9215)
+       && serial->interface->cur_altsetting->desc.bInterfaceNumber >= 4)
+       return -ENODEV;
+
+   //Quectel EC25&EC21&EG91&EG95&EG06&EP06&EM06&BG96/AG35's interface 4 can be used as USB network device
+   if (serial->dev->descriptor.idVendor == cpu_to_le16(0x2C7C)
+       && serial->interface->cur_altsetting->desc.bInterfaceNumber >= 4)
+       return -ENODEV;
+
 	/* Store the device flags so we can use them during attach. */
 	usb_set_serial_data(serial, (void *)device_flags);
 
